#include <conio.h>
#include <stdlib.h>
#include <stdio.h>
#include <dos.h>
#include <bios.h>
#include <string.h>
#include <stdarg.h>
#include <values.h>

#include "tcp.h"
#undef byte

/**********************   UDP / IP SUPPORT *************************/

    udp_Socket          telsock;
    static              udp_Socket *s;
    unsigned char       buffer[2400];
   
    unsigned long       host;
    unsigned long       rhost ;
    unsigned int        port;
    int status;
#define PORT 1001

#define CLOCK_DATA              14
#define CLOCK_SETUP             0x98
#define INPUT_SETUP             0xC1
#define QUAD_X1                 0xA8
#define QUAD_X2                 0xB0
#define QUAD_X4                 0xB8
#define BP_RESET                        0x01
#define BP_RESETB                       0x81
#define CNTR_RESET              0x02
#define CNTR_RESETB             0x82
#define TRSFRPR_CNTR            0x08
#define TRSFRCNTR_OL            0x90
#define EFLAG_RESET             0x86
#define INDEX_DISABLE   0xE0
//****************************************************************************




void Bigprint(char);
void Screensetup();
void Parse_and_Print(char*);
int LS7266Init();
long LS7266ReadX();
long LS7266ReadY();
long LS7266ReadZ();
long LS7266ReadW();
void LS7266WriteX(long);
void LS7266WriteY(long);
void LS7266WriteZ(long);
void LS7266WriteW(long);

float Axis[4];



#define  BASE7266  544

int XAXISDATA=BASE7266+0;
int XAXISCTRL=BASE7266+1;
int YAXISDATA=BASE7266+2;
int YAXISCTRL=BASE7266+3;
int ZAXISDATA=BASE7266+4;
int ZAXISCTRL=BASE7266+5;
int WAXISDATA=BASE7266+6;
int WAXISCTRL=BASE7266+7;



int fourthaxis=0;

FILE *setupfile;

int init;

main(){
	char *buf, keyhit, readin[10];
	int xres=1000, yres=1000, zres=1000, errorcode=0,
	lathemode=1, stepcnt=0, quitcode=0, unitmode=0,
      startup=1;
   float time, unitfactor=1.00, wres=20.5254;
   double temp;
	long clck=1, xread=1, oldx, yread=1, oldy, zread=1, oldz,
	wread=1, oldw, synchro, oldclck=clck-1;
   long xbacklash, ybacklash, zbacklash, wbacklash, xtop, xbot,
	ytop, ybot, ztop, zbot, wtop, wbot, xreal=0, yreal=0,
      zreal=0, wreal=0;
   _bios_timeofday(_TIME_GETCLOCK, &clck);
  // FILE *setupfile;

   if ( (setupfile = fopen("dro.cfg", "rt") ) == NULL )
   {
      printf("Cannot open setupfile file dro.cfg!\n");
		errorcode++;
   }

   fgets(readin, 10, setupfile);
//   BASE7266=atoi(readin);
   XAXISDATA=BASE7266+0;
	XAXISCTRL=BASE7266+1;
	YAXISDATA=BASE7266+2;
	YAXISCTRL=BASE7266+3;
   ZAXISDATA=BASE7266+4;
	ZAXISCTRL=BASE7266+5;
	WAXISDATA=BASE7266+6;
	WAXISCTRL=BASE7266+7;

 init=LS7266Init();
   if (init!=0){
	printf("No card detected!\n");
	errorcode++;
   }

	   fgets(readin, 10, setupfile);
	   xres=atoi(readin);
	   fgets(readin, 10, setupfile);
	   yres=atoi(readin);
	   if (!fourthaxis)
		{
			fgets(readin, 10, setupfile);
		   zres=atoi(readin);
		fgets(readin, 10, setupfile);
		wres=atof(readin);
	   }
	   fgets(readin, 10, setupfile);
	   temp=atof(readin);
      xbacklash=temp*xres;
      xtop=xbacklash/2;
      xbot= -xbacklash/2;
	   fgets(readin, 10, setupfile);
	   temp=atof(readin);
      ybacklash=temp*yres;
      ytop=ybacklash/2;
      ybot= -ybacklash/2;
	   if (!fourthaxis)
	   {
		fgets(readin, 10, setupfile);
			temp=atof(readin);
	zbacklash=temp*zres;
	ztop=zbacklash/2;
	zbot= -zbacklash/2;
		fgets(readin, 10, setupfile);
			temp=atof(readin);
	wbacklash=temp*wres;
	wtop=wbacklash/2;
	wbot= -wbacklash/2;
	   }

   //if (errorcode!=0) return (errorcode);

   printf("Errorcode = %d\n", errorcode);
   printf("Math CPU = %d       (Zero: No MPU         Nonzero: MPU Present)\n", _8087);
   printf("Fourth Axis = %d    (Zero: 3-4 detected   Nonzero: Error)\n", fourthaxis);
   printf("Hit any key to continue...\n");
   getch();

   clrscr();

   UDPOpen();
   getch();
   clrscr();






//        Screensetup();

	while ( quitcode!=1 )
	{

      // Loop timer sequence
		if (stepcnt==2000)
		{
			oldclck=clck;
			_bios_timeofday(_TIME_GETCLOCK, &clck);
	 synchro=clck;
	 while (clck==synchro){
				_bios_timeofday(_TIME_GETCLOCK, &synchro);
	 }
			time=(clck-oldclck)/18.200;
			gotoxy(13,22);
			cprintf( "%2.3f ms/loop     ", time/2 );
			stepcnt=0;
		}
		stepcnt++;
      // X axis read/display sequence
      oldx=xreal;
      xread=LS7266ReadX();
      if (xread>xtop){
	xtop=xread;
	 xbot=xread-xbacklash;
	 xreal=xtop;
      }
      if (xread<xbot){
	xbot=xread;
	 xtop=xread+xbacklash;
	 xreal=xtop;
      }
		if ( (oldx!=xreal) || (startup==1) )
      {
	temp=xreal;
	temp=unitfactor*temp/xres;
	if (!unitmode) Axis[0] = temp;
	else Axis[0] = temp;
		
      }


      // Y axis read/display sequence
      oldy=yreal;
      yread=LS7266ReadY();
      if (yread>ytop){
	ytop=yread;
	 ybot=yread-ybacklash;
	 yreal=ytop;
      }
      if (yread<ybot){
	ybot=yread;
	 ytop=yread+ybacklash;
	 yreal=ytop;
      }
      if ( (oldy!=yreal) || (startup==1) )
      {
	temp=yreal;
	temp=unitfactor*(lathemode*temp)/yres;
	if (!unitmode) Axis[1] = temp;
	else Axis[1] = temp;
   
      }
      if (!fourthaxis)
      {
			// Z axis read/display sequence
			oldz=zreal;
			zread=LS7266ReadZ();
	      if (zread>ztop){
		ztop=zread;
	   zbot=zread-zbacklash;
		zreal=ztop;
	}
	if (zread<zbot){
		zbot=zread;
		ztop=zread+zbacklash;
		zreal=ztop;
	}
			if ( (oldz!=zreal) || (startup==1) )
			{
				temp=zreal;
				temp=unitfactor*temp/zres;
		if (!unitmode) Axis[2] = temp;
		else Axis[2] = temp;
				

			  }      

   //   W axis read/display sequence
			oldw=wreal;
			wread=LS7266ReadW();
	if (wread>wtop){
		wtop=wread;
		wbot=wread-wbacklash;
		wreal=wtop;
	}
	if (wread<wbot){
		wbot=wread;
		wtop=wread+wbacklash;
		wreal=wtop;
	}
			if ( (oldw!=wreal) || (startup==1) )
			{
				temp=wreal;
				temp=temp/wres;
				Axis[3] = temp;
				

				

       
			}



  //     printf("x:%g, y:%g, z:%g, w:%g\n",
//       Axis[0],Axis[1],Axis[2],Axis[3]);
UDPwrite();

      }
      startup=0;
		// zeroaxis sequence
      if (kbhit()){
	keyhit=getch();
	 if ( (keyhit=='x') || (keyhit=='X') ){
	    LS7266WriteX(xread-xreal);
	    xtop=xtop-xreal;
	    xbot=xbot-xreal;
	    xreal=0;
		temp=xreal;
		temp=unitfactor*temp/xres;
		if (!unitmode) Axis[0]=temp;
		else Axis[0] = temp;
				

			       

			  
	 }
	 else if ( (keyhit=='y') || (keyhit=='Y') ){
	    LS7266WriteY(yread-yreal);
	    ytop=ytop-yreal;
	    ybot=ybot-yreal;
	    yreal=0;
		temp=yreal;
		temp=unitfactor*(lathemode*temp)/yres;
		if (!unitmode) Axis[1] = temp;
		else Axis[1] = temp;
				

				

			
	 }
	 else if ( (keyhit=='z') || (keyhit=='Z') ){
	    LS7266WriteZ(zread-zreal);
	    ztop=ztop-zreal;
	    zbot=zbot-zreal;
	    zreal=0;
				temp=zreal;
				temp=unitfactor*temp/zres;
		if (!unitmode) Axis[2] = temp;
		else Axis[2] = temp;
				

				

			  
	 }
	 else if ( (keyhit=='w') || (keyhit=='W') ){
	    LS7266WriteW(wread-wreal);
	    wtop=wtop-wreal;
	    wbot=wbot-wreal;
	    wreal=0;
				temp=wreal;
				temp=temp/wres;
				Axis[3] = temp;
				
			  
			  }
	 else if ( (keyhit=='u') || (keyhit=='U') ){
		if (unitmode==0)
	    {
		unitmode=1;
	       unitfactor=25.4;
	    }
	    else
	    {
		unitmode=0;
	       unitfactor=1;
	    }
		temp=xread;
		temp=unitfactor*temp/xres;
			if (!unitmode) Axis[0] = temp;
			else Axis[0] = temp;
				

				
			temp=yread;
			temp=unitfactor*(lathemode*temp)/yres;
		if (!unitmode) Axis[1] = temp;
		else Axis[1] = temp;
				

				

			   
	    if (!fourthaxis)
	    {
					temp=zread;
					temp=unitfactor*temp/zres;
			if (!unitmode) Axis[2] = temp;
			else Axis[2] = temp;
					
					

				  
	    }
	 }
	 else if ( (keyhit=='d') || (keyhit=='D') ){
		if (lathemode==1){
		lathemode=2;
		gotoxy(43,22);
					cprintf("Y-axis in diameter mode");
	    }
	    else {
		lathemode=1;
		gotoxy(43,22);
					cprintf("Y-axis in radius mode  ");
				}
		temp=yread;
			temp=unitfactor*(lathemode*temp)/yres;
		 Axis[3] = temp;
	     
		
	 }







	  if ( (keyhit=='Q') || (keyhit=='q') || (keyhit==' ') ) quitcode=1;    
      }
	
	}


		   


   fclose(setupfile);
	_setcursortype(_NORMALCURSOR);
	textcolor(15);
	textbackground(0);
	textmode(LASTMODE);
	clrscr();
   return(0);
}

////////////  LS7266Init
int LS7266Init(){
	int failx=0, faily=0, failz=0, failw=0;
   outportb(XAXISCTRL, INDEX_DISABLE);
   outportb(XAXISCTRL, EFLAG_RESET);
   outportb(XAXISCTRL, BP_RESETB);
   outportb(XAXISDATA, CLOCK_DATA);
   outportb(XAXISCTRL, CLOCK_SETUP);
   outportb(XAXISCTRL, INPUT_SETUP);
   outportb(XAXISCTRL, QUAD_X4);
   outportb(XAXISCTRL, CNTR_RESETB);

   outportb(XAXISCTRL, 184);
   outportb(XAXISCTRL, 135);
   outportb(XAXISCTRL, 133);
   outportb(XAXISCTRL, 131);
   outportb(XAXISCTRL, 193);
   outportb(XAXISCTRL, 224);

   outportb(XAXISCTRL, BP_RESET);
   outportb(XAXISDATA, 1);
   outportb(XAXISDATA, 2);
   outportb(XAXISDATA, 3);

   outportb(XAXISCTRL, TRSFRPR_CNTR);
   outportb(XAXISCTRL, TRSFRCNTR_OL);
   outportb(XAXISCTRL, CNTR_RESET);

   outportb(XAXISCTRL, BP_RESET);
   if (inportb(XAXISDATA)!=1) failx++;
   if (inportb(XAXISDATA)!=2) failx++;
   if (inportb(XAXISDATA)!=3) failx++;

   outportb(YAXISCTRL, BP_RESET);
   outportb(YAXISDATA, 4);
   outportb(YAXISDATA, 5);
   outportb(YAXISDATA, 6);

   outportb(YAXISCTRL, TRSFRPR_CNTR);
   outportb(YAXISCTRL, TRSFRCNTR_OL);
   outportb(YAXISCTRL, CNTR_RESET);
   outportb(YAXISCTRL, BP_RESET);
   if (inportb(YAXISDATA)!=4) faily++;
   if (inportb(YAXISDATA)!=5) faily++;
   if (inportb(YAXISDATA)!=6) faily++;

   outportb(ZAXISCTRL, INDEX_DISABLE);
   outportb(ZAXISCTRL, EFLAG_RESET);
   outportb(ZAXISCTRL, BP_RESETB);
   outportb(ZAXISDATA, CLOCK_DATA);
   outportb(ZAXISCTRL, CLOCK_SETUP);
   outportb(ZAXISCTRL, INPUT_SETUP);
   outportb(ZAXISCTRL, QUAD_X4);
   outportb(ZAXISCTRL, CNTR_RESETB);

   outportb(ZAXISCTRL, 184);
   outportb(ZAXISCTRL, 135);
   outportb(ZAXISCTRL, 133);
   outportb(ZAXISCTRL, 131);
   outportb(ZAXISCTRL, 193);
   outportb(ZAXISCTRL, 224);

   outportb(ZAXISCTRL, BP_RESET);
   outportb(ZAXISDATA, 7);
   outportb(ZAXISDATA, 8);
   outportb(ZAXISDATA, 9);

   outportb(ZAXISCTRL, TRSFRPR_CNTR);
   outportb(ZAXISCTRL, TRSFRCNTR_OL);
   outportb(ZAXISCTRL, CNTR_RESET);

   outportb(ZAXISCTRL, BP_RESET);
   if (inportb(ZAXISDATA)!=7) failz++;
   if (inportb(ZAXISDATA)!=8) failz++;
   if (inportb(ZAXISDATA)!=9) failz++;

   outportb(WAXISCTRL, BP_RESET);
   outportb(WAXISDATA, 10);
   outportb(WAXISDATA, 11);
   outportb(WAXISDATA, 12);

   outportb(WAXISCTRL, TRSFRPR_CNTR);
   outportb(WAXISCTRL, TRSFRCNTR_OL);
   outportb(WAXISCTRL, CNTR_RESET);
   outportb(WAXISCTRL, BP_RESET);
   if (inportb(WAXISDATA)!=10) failw++;
   if (inportb(WAXISDATA)!=11) failw++;
   if (inportb(WAXISDATA)!=12) failw++;

	fourthaxis=failz+failw;

   return(failx+faily);
}
////////////  End LS7266Init

////////////  LS7266WriteX
void LS7266WriteX(long in){
		union pos_tag {
	long l;
	 struct byte_tag { char b0; char b1; char b2; char b3;} byte;
      } pos;
      pos.l=in;
	outportb(XAXISCTRL, BP_RESET);
	outportb(XAXISDATA, pos.byte.b0);
	outportb(XAXISDATA, pos.byte.b1);
	outportb(XAXISDATA, pos.byte.b2);
	outportb(XAXISCTRL, TRSFRPR_CNTR);
	outportb(XAXISCTRL, TRSFRCNTR_OL);
	outportb(XAXISCTRL, BP_RESET);
      return;
}
////////////  End LS7266WriteX

////////////  LS7266WriteY
void LS7266WriteY(long in){
		union pos_tag {
	long l;
	 struct byte_tag { char b0; char b1; char b2; char b3;} byte;
      } pos;
      pos.l=in;
	outportb(YAXISCTRL, BP_RESET);
	outportb(YAXISDATA, pos.byte.b0);
	outportb(YAXISDATA, pos.byte.b1);
	outportb(YAXISDATA, pos.byte.b2);
	outportb(YAXISCTRL, TRSFRPR_CNTR);
	outportb(YAXISCTRL, TRSFRCNTR_OL);
	outportb(YAXISCTRL, BP_RESET);
      return;
}
////////////  End LS7266WriteY

////////////  LS7266WriteZ
void LS7266WriteZ(long in){
		union pos_tag {
	long l;
	 struct byte_tag { char b0; char b1; char b2; char b3;} byte;
      } pos;
      pos.l=in;
	outportb(ZAXISCTRL, BP_RESET);
	outportb(ZAXISDATA, pos.byte.b0);
	outportb(ZAXISDATA, pos.byte.b1);
	outportb(ZAXISDATA, pos.byte.b2);
	outportb(ZAXISCTRL, TRSFRPR_CNTR);
	outportb(ZAXISCTRL, TRSFRCNTR_OL);
	outportb(ZAXISCTRL, BP_RESET);
      return;
}
////////////  End LS7266WriteZ

////////////  LS7266WriteW
void LS7266WriteW(long in){
		union pos_tag {
	long l;
	 struct byte_tag { char b0; char b1; char b2; char b3;} byte;
      } pos;
      pos.l=in;
	outportb(WAXISCTRL, BP_RESET);
	outportb(WAXISDATA, pos.byte.b0);
	outportb(WAXISDATA, pos.byte.b1);
	outportb(WAXISDATA, pos.byte.b2);
	outportb(WAXISCTRL, TRSFRPR_CNTR);
	outportb(WAXISCTRL, TRSFRCNTR_OL);
	outportb(WAXISCTRL, BP_RESET);
      return;
}
////////////  End LS7266WriteW

////////////  LS7266ReadX
long LS7266ReadX(){
		union pos_tag {
	long l;
	 struct byte_tag { char b0; char b1; char b2; char b3;} byte;
      } pos;
      outportb(XAXISCTRL, TRSFRCNTR_OL);
      outportb(XAXISCTRL, BP_RESET);
      pos.byte.b0=inportb(XAXISDATA);
      pos.byte.b1=inportb(XAXISDATA);
      pos.byte.b2=inportb(XAXISDATA);
      if (pos.byte.b2 < 0) pos.byte.b3 = -1;
      else pos.byte.b3 = 0;
      return pos.l;
}
////////////  End LS7266ReadX

////////////  LS7266ReadY
long LS7266ReadY(){
		union pos_tag {
	long l;
	 struct byte_tag { char b0; char b1; char b2; char b3;} byte;
      } pos;

      outportb(YAXISCTRL, TRSFRCNTR_OL);
      outportb(YAXISCTRL, BP_RESET);
      pos.byte.b0=inportb(YAXISDATA);
      pos.byte.b1=inportb(YAXISDATA);
      pos.byte.b2=inportb(YAXISDATA);
      if (pos.byte.b2 < 0) pos.byte.b3 = -1;
      else pos.byte.b3 = 0;
      return pos.l;
}
////////////  End LS7266ReadY

////////////  LS7266ReadZ
long LS7266ReadZ(){
		union pos_tag {
	long l;
	 struct byte_tag { char b0; char b1; char b2; char b3;} byte;
      } pos;
      outportb(ZAXISCTRL, TRSFRCNTR_OL);
      outportb(ZAXISCTRL, BP_RESET);
      pos.byte.b0=inportb(ZAXISDATA);
      pos.byte.b1=inportb(ZAXISDATA);
      pos.byte.b2=inportb(ZAXISDATA);
      if (pos.byte.b2 < 0) pos.byte.b3 = -1;
      else pos.byte.b3 = 0;
      return pos.l;
}
////////////  End LS7266ReadZ

////////////  LS7266ReadW
long LS7266ReadW(){
		union pos_tag {
	long l;
	 struct byte_tag { char b0; char b1; char b2; char b3;} byte;
      } pos;
      outportb(WAXISCTRL, TRSFRCNTR_OL);
      outportb(WAXISCTRL, BP_RESET);
      pos.byte.b0=inportb(WAXISDATA);
      pos.byte.b1=inportb(WAXISDATA);
      pos.byte.b2=inportb(WAXISDATA);
      if (pos.byte.b2 < 0) pos.byte.b3 = -1;
      else pos.byte.b3 = 0;
      return pos.l;
}
////////////  End LS7266ReadW

////////////  Parse and Print numbers w/ decimal
////////////  End Parse and Print


/////////////  Screen setup
////////////  End screen setup
/*

udp transfer program 
*/





int UDPOpen( )
{




    printf("Opening UDP Socket\n");
    sock_init();
    s = (udp_Socket *)&telsock;
    /* Open the udp connection (?!) */
    if( !udp_open( s, PORT, rhost, PORT, NULL))
    {
	printf("Unable to open udp connection\n");
	exit(0);
    }

    


    /* turn off UDP checksums */
    sock_mode( s, UDP_MODE_NOCHK );


};     


int UDPwrite(void)
{



sock_write(s,&(Axis), sizeof(Axis));
tcp_tick(NULL);
}
     

void UDPClose( void )
{
    printf("Closing UDP Socket\n");
    sock_close( s );
};





